Subject: [netmod] Question regarding RFC 8344

From: Peter Schneider <[email-masked]>
Date: Thu, 11 Jul 2019 17:04:26 +0000

Hi,

I stumbled on an incompatibility between the IP Management YANG Module and the real world:
In the 'container ipv4', the leaf 'mtu' is declared as uint16 in the range 68..max, which is effective the range 68..65535, as noted in rfc 7950<https://tools.ietf.org/html/rfc7950#section-9.2> .
On the other side, the default MTU size of the loopback interface in Linux is 65536 since several years.
Depending on the used netconf client, the client either reports (correctly) an error when getting / configuring the loopback interface, or silently reduces /raises the shown resp. configured value for the mtu.

Are there any statements available on this issue?

Kind Regards,

Peter Schneider
--
Peter Schneider
Software Engineer R&D
Kontron
Heinrich-Barth-Strasse 1-1a | 66115 Saarbrücken | Germany
P: +49 681 95916 206
[email-masked]<mailto:[email-masked]>

Website<http://www.kontron.com/> | Blog<http://blog.kontron.com/> | Twitter<https://twitter.com/Kontron> | LinkedIn<https://www.linkedin.com/company/kontron> | YouTube<https://www.youtube.com/channel/UCXkp_1gJbG0Um1vzdowlqww> | Facebook<https://www.facebook.com/kontron>

Kontron Europe GmbH
Die gesetzlichen Pflichtangaben finden Sie hier<http://www.kontron.de/additional/impressum>.
Please find our mandatory legal statements hier<http://www.kontron.com/additional/disclaimer>.
Mit dem Öffnen dieses E-Mails stimmen Sie Kontrons Richtlinien zur elektronischen Kommunikation<http://www.kontron.de/additional/rechtliche-hinweise> zu.
By opening this email you are agreeing to Kontron's Electronic Communications Policy<http://www.kontron.com/additional/legal-and-copyright-information>

---

From: Vladimir Vassilev <[email-masked]>
Date: Mon, 15 Jul 2019 01:06:35 +0200

On 7/11/19 7:04 PM, Peter Schneider wrote:
> In the 'container ipv4', the leaf 'mtu' is declared as uint16 in the 
> range 68..max, which is effective the range 68..65535, as noted in rfc 
> 7950 <https://tools.ietf.org/html/rfc7950#section-9.2> .

I don't think there is a problem with RFC 8344 since the ipv4 protocol 
MTU can not exceed 65535 bytes (RFC 791). The maximum payload supported 
by an interface which is the case with the default value of the lo 
interface MTU on your Linux distribution (seems this can be configured 
to up to 2147483647 octets at least on mine) has to be greater then the 
MTUs of all protocols (ipv4,ipv6 etc.) supported on that interface but 
they do not need to be equal. It is indeed recommended that the maximum 
"length of the data field of a packet" is used as defined in RFC 894 
e.g. 1500 for ethernet but you can choose or be constrained (like in 
this case) to not do so.

Currently there is no IETF RFC module that has data definition for 
control of the interface MTU used as an upper limit for all protocol MTUs.

FYI there is a /interfaces/interface/l2-mtu leaf proposed in 
draft-ietf-netmod-intf-ext-yang-07 where an uint16 type should probably 
be changed to uint32.

IMO  "/interfaces/interface/mtu" leaf is needed that actually 
corresponds to the maximum length of the data field of a packet and 
already referred to in popular software like Linux as "interface MTU" 
(there is no standard this is based on just running software as far as I 
am aware) should be added in addition to the l2-mtu leaf. Then in your 
case this leaf would be configured to 65536 for the lo interface while 
the /interfaces/interface/ipv4/mtu can be less then that.

/ Vladimir

> Depending on the used netconf client, the client either reports 
> (correctly) an error when getting / configuring the loopback 
> interface, or silently reduces /raises the shown resp. configured 
> value for the mtu.
>
> Email Signature of <a class="moz-txt-link-abbreviated" 
> href="mailto:[email-masked]">[email-masked]</a> 
> *Peter Schneider*
> Software Engineer R&D
> *Kontron*
> [email-masked] <mailto:[email-masked]>
>
> Website <http://www.kontron.com/> | Blog <http://blog.kontron.com/> | 
> Twitter <https://twitter.com/Kontron> | LinkedIn 
> <https://www.linkedin.com/company/kontron> | YouTube 
> <https://www.youtube.com/channel/UCXkp_1gJbG0Um1vzdowlqww> | Facebook 
> <https://www.facebook.com/kontron>
>
> *Kontron Europe GmbH*
> Die gesetzlichen Pflichtangaben finden Sie hier 
> <http://www.kontron.de/additional/impressum>.
> Please find our mandatory legal statements hier 
> <http://www.kontron.com/additional/disclaimer>.
> Mit dem Öffnen dieses E-Mails stimmen Sie Kontrons Richtlinien zur 
> elektronischen Kommunikation 
> <http://www.kontron.de/additional/rechtliche-hinweise> zu.
> By opening this email you are agreeing to Kontron's Electronic 
> Communications Policy 
> <http://www.kontron.com/additional/legal-and-copyright-information>
>
> _______________________________________________
> netmod mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netmod

---

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Fri, 19 Jul 2019 10:23:20 +0000

Hi,

draft-ietf-netmod-intf-ext-yang-07, in WGLC, defines just such an MTU config item (called l2-mtu).

This is currently defined as a uint16, but perhaps this could/should be defined as uint32 instead.

Thanks,
Rob

-----Original Message-----
From: Vladimir Vassilev <[email-masked]> 
Sent: 15 July 2019 00:07
To: Peter Schneider <[email-masked]>; [email-masked]; [email-masked]
Subject: Re: [netmod] Question regarding RFC 8344

> Linux is 65536 since several years.

I don't think there is a problem with RFC 8344 since the ipv4 protocol MTU can not exceed 65535 bytes (RFC 791). The maximum payload supported by an interface which is the case with the default value of the lo interface MTU on your Linux distribution (seems this can be configured to up to 2147483647 octets at least on mine) has to be greater then the MTUs of all protocols (ipv4,ipv6 etc.) supported on that interface but they do not need to be equal. It is indeed recommended that the maximum "length of the data field of a packet" is used as defined in RFC 894 e.g. 1500 for ethernet but you can choose or be constrained (like in this case) to not do so.

Currently there is no IETF RFC module that has data definition for control of the interface MTU used as an upper limit for all protocol MTUs